/* $USAGI: ipip.h,v 1.3 2001/07/16 11:13:26 yoshfuji Exp $ */

#ifndef __NET_IPIP_H
#define __NET_IPIP_H 1

#include <linux/if_tunnel.h>

/* Keep error state on tunnel for 30 sec */
#define IPTUNNEL_ERR_TIMEO	(30*HZ)

struct ip_tunnel
{
	struct ip_tunnel	*next;
	struct device		*dev;
	struct net_device_stats	stat;

	int			recursion;	/* Depth of hard_start_xmit recursion */
	int			err_count;	/* Number of arrived ICMP errors */
	unsigned long		err_time;	/* Time when the last ICMP error arrived */

	/* These four fields used only by GRE */
	__u32			i_seqno;	/* The last seen seqno	*/
	__u32			o_seqno;	/* The last output seqno */
	int			hlen;		/* Precalculated GRE header length */
	int			mlink;

	struct ip_tunnel_parm	parms;
};

extern int	ipip_init(void);
#ifdef CONFIG_NET_IPIP_IPV6
struct ip_tunnel *ipip_tunnel_lookup(u32 remote, u32 local);
#endif
extern int	ipgre_init(void);
extern int	sit_init(void);
extern void	sit_cleanup(void);

#endif
